<template>
	<view>
		<image src="/static/icon/background.png" mode="" class="background"></image>
		<view  class="project-content">
		<u-form :model="form" :rules="rules" ref="form" >
			<u-form-item label=" " borderBottom ref="item1">
				<view>警示柱信息</view>
				<u-input v-model="form.warningPileInfo"  :disabled="type==1" type="textarea" ></u-input>
			</u-form-item>
			<u-form-item label=" "  borderBottom ref="item1">
				<view>警示柱照片</view>
				<view class="" style="display: flex; flex-wrap: wrap; margin: 0 55rpx;">
					<image src="/static/icon/chooseimg.png" mode="" style="width: 190rpx; height: 190rpx; margin: 0 12rpx; "
						@click="choose()" v-if="type!=1"></image>
					<view v-for="(item,index) in imgymxs" :key="index" style="position: relative;">
						<view v-if="item.type == 'image'">
							<image :src="item.url" mode=""
								style="width: 190rpx; height: 190rpx; margin: 0 20rpx;" @click="showPhoto(index)">
							</image>
						</view>
						<view v-else>
							<video :src="item"
								style="width: 190rpx; height: 190rpx; margin: 0 20rpx;"></video>
						</view>
						<view @click="remove(index)" style="position: absolute; top: 0; right: 14rpx; border-radius: 50%; background-color: #FF0000;">
							<u-icon name="close" color="#FFFFFF" size="35" ></u-icon> 
						</view>
					</view>
				</view>
			</u-form-item>
			</u-form>
			<u-button style="margin: 500rpx 155rpx 0;" @click="save()" v-if="type!=1">确认上传</u-button>
			</view>
			</view>
</template>

<script>
import service from '@/api/index.js'
	export default {
		data() {
			return {
				action: this.$HTTP.webUrl + `/obs`,
								headers: {
									MAuthorization: "wxBearer " + uni.getStorageSync('token')
								},
								url: [],
								uploading: false,
									imgymxs: [],
									progress: 0 ,//图片或视频上传百分比
				form:{},
				value:null,
				imgArr: [],
				type:2,
				id:null
				
			}
		},
		onLoad(e)
		{
			console.log(e)
			this.id=e.id
			if(e.type==1)
			{
				this.type=e.type
				console.log(this.id)
				service.getwarningPile(this.id).then(res => {
					this.form=res
					//this.imgymxs=res.photoList
					if(null!=res.photoList)
					{
						res.photoList.forEach(item=>{
							let url={}
							url.url=item
							url.type='image'
							this.imgymxs.push(url)
						})
					}
				})
			}else{
				this.getwarningPileInfo(e.value)
			}
			uni.setNavigationBarTitle({
					title: '抢险维修单'
			});
		},
		methods: {
			showPhoto(index){
				uni.previewImage({
					current:index,
					urls:this.imgArr,
				})
			},
			showPhotos(index){
				uni.previewImage({
					current:index,
					urls:this.photo,
				})
			},
			getwarningPileInfo(value)
			{
				service.getwarningPileInfo(value).then(res => {
					this.form=res
					if(null!=res.photoList)
					{
						//this.imgymxs=res.photoList
						if(null!=res.photoList)
						{
							res.photoList.forEach(item=>{
								let url={}
								url.url=item
								url.type='image'
								this.imgymxs.push(url)
							})
						}
					}
					console.log(this.imgymxs)
					
				})
			},
			save()
			{
				let _this=this
				this.form.photoList=this.imgArr
				service.setwarningPile(this.form
				).then(res => {
					console.log(res)
					_this.$UTILS.showPrompt('上报成功')
					setTimeout(()=>{
						console.log('跳')
						uni.switchTab({
							url: `/pages/index/index`
						})
					},2000)
					})
			},
			choose() {
				let _this = this;
				uni.showActionSheet({
					title: '上传',
					itemList: ['图片', '视频'],
					success: (res) => {
						// console.log(res)
						if (res.tapIndex == 0) {
							this.chooseimage()
						} else {
							this.choosevideo()
						}
					}
				})
			},
			chooseimage() {
				console.log('图片')
				let _this = this;
				uni.chooseImage({
					sizeType: [ 'camera'],
					success(resp) {
						console.log('res--uni.chooseMedia', resp);
						resp.tempFiles.forEach((item, index) => {
							const task = uni.uploadFile({
								url: _this.$HTTP.webUrl + `/obs`,
								filePath: item.path,
								name: 'file',
								formData: {},
								header: _this.headers,
								success: res => {
									// 判断是否json字符串，将其转为json格式
									let data = _this.$u.test.jsonString(res
										.data) ? JSON.parse(res.data) : res.data;
									if (![200, 201, 204].includes(res.statusCode)) {
										// this.uploadError(index, data);
										_this.$UTILS.showPrompt('选取失败！')
									} else {
										// 上传成功
										// this.lists[index].response = data;
										// this.lists[index].progress = 100;
										// this.lists[index].error = false;
										// this.$emit('on-success', data, index, this.lists, this
										// 	.index);
										if (_this.progress === 100) {
											// console.log('_this.progress', _this.progress)
											// console.log('data----', data)
											// console.log('res--', res)
											_this.imgymxs.push({url:data.data.url,type:'image'})
											_this.imgArr.push(data.data.url)
											// console.log('imgArr', _this.imgArr)
											_this.$UTILS.showPrompt('选取成功！')
										}
									}
								},
								fail: e => {
									_this.$UTILS.showPrompt('选取失败！')
									this.uploadError(index, e);
								},
								complete: res => {
									_this.uploading = false;
									// _this.uploadFile(index + 1);
									// this.$emit('on-change', res, index, this.lists, this
									// .index);
								}
							});
							task.onProgressUpdate(res => {
								// if (res.progress > 0) {
								// 	this.lists[index].progress = res.progress;
								// 	this.$emit('on-progress', res, index, this.lists, this.index);
								// }
								_this.progress = res.progress;
								console.log('onProgressUpdate', res)
								uni.showLoading({
									title: '选取中'
								})
							});
						})
					},
				})
			},
			choosevideo() {
				let _this = this;
				console.log('视频')
				uni.chooseVideo({
					sourceType: ['camera'],
					maxDuration: 30,
					success(resp) {
						const task = uni.uploadFile({
							url: _this.$HTTP.webUrl + `/obs`,
							filePath: resp.tempFilePath,
							name: 'file',
							formData: {},
							header: _this.headers,
							success: res => {
								// 判断是否json字符串，将其转为json格式
								let data = _this.$u.test.jsonString(res
									.data) ? JSON.parse(res.data) : res.data;
								if (![200, 201, 204].includes(res.statusCode)) {
									this.uploadError(index, data);
								} else {
									// 上传成功
									// this.lists[index].response = data;
									// this.lists[index].progress = 100;
									// this.lists[index].error = false;
									// this.$emit('on-success', data, index, this.lists, this
									// 	.index);	
									if (_this.progress === 100) {
										console.log('_this.progress', _this.progress)
										console.log('data----', data)
										console.log('res--', res)
										// _this.imgArr.push(data.data.url)
										_this.imgymxs.push({url:data.data.url,type:'video'})
										_this.imgArr.push(data.data.url)
										console.log('imgArr', _this.imgArr)
										_this.$UTILS.showPrompt('选取成功！')
									} 
								}
							},
							fail: e => {
								_this.$UTILS.showPrompt('选取失败！')
								this.uploadError(index, e);
							},
							complete: res => {
								uni.hideLoading();
								_this.uploading = false;
								// _this.uploadFile(index + 1);
								// this.$emit('on-change', res, index, this.lists, this
								// .index);
							}
						});
						task.onProgressUpdate(res => {
							// if (res.progress > 0) {
							// 	this.lists[index].progress = res.progress;
							// 	this.$emit('on-progress', res, index, this.lists, this.index);
							// }
							_this.progress = res.progress;
							console.log('onProgressUpdate', res)
							uni.showLoading({
								title: '选取中'
							})
						});
			
					},
				})
			},
			remove(index) {
				uni.showModal({
					title: '提示',
					content: '是否删除该图片或视频？',
					success: (res) => {
						if (res.confirm) {
							this.imgArr.splice(index, 1);
							this.imgymxs.splice(index, 1);
							console.log('this.imgarr',this.imgArr)
						}
					}
				})
			},
		}
	}
</script>

<style>
	
.project-content {
		border: 4rpx solid #3857F3;
		margin: 40rpx 55rpx 0;
		padding: 30rpx 20rpx;
		border-radius: 48rpx;
	}
	.background {
		z-index: -1;
		position: fixed;
		width: 100%;
		height: 100%;
		background-size: 100% 100%;
	}
</style>
